capture program drop qlt
program define qlt, byable(recall)

syntax

di "Durée pour différents quantiles de la fonction de survie"

marksample touse

local q 0.90 0.75 0.50 0.25 0.10

foreach q2 of local q {
preserve
qui capture keep if `touse'
qui gen mdif=abs(survival-`q2')
qui gen mdif2=mdif-mdif[_n-1]
qui drop if mdif2==0
qui gen s2=survival[_n+1]
qui gen t02=t0[_n+1]
qui replace s2=0 if s2==.
qui gen x=1 if survival>=`q2' & s2<=`q2'
qui keep if x==1
qui gen tq=t0 + (t02-t0)*(survival-`q2')/(survival-s2) 
qui replace tq=. if tq<=0
qui sum t02
qui replace tq=. if tq>`r(max)'
qui sum tq 
di as text "S(t)=`q2': t="as result %9.3f r(max)
restore
}
end

